function switchVisibility(obj) {
    var el = document.getElementById(obj);
    if (typeof el !== 'undefined' && el !== null) {
        if ( el.style.display != "none" ) {
            el.style.display = 'none';
            return false;
        } else {
            el.style.display = 'block';
            return true;
        }
    }
    return false;
}

function setVisibility(obj, visible) {
    var el = document.getElementById(obj);
    if (typeof el !== 'undefined' && el !== null) {
        if (!visible) {
            el.style.display = 'none';
        } else {
            el.style.display = 'block';
        }
    }
}

function switchRevealClassActive(obj) {
    var el = document.getElementById(obj);
    if (typeof el !== 'undefined' && el !== null) {
        var newActive = el.classList.contains("reveal");
        el.classList.toggle("reveal", !newActive);
        el.classList.toggle("reveal-active", newActive);
        return newActive;
    }
    return false;
}
function setRevealClassActive(obj, active) {
    var el = document.getElementById(obj);
    if (typeof el !== 'undefined' && el !== null) {
        el.classList.toggle("reveal", !active);
        el.classList.toggle("reveal-active", active);
    }
}

function switchClassVisibility(className) {
    var elList = document.getElementsByClassName(className);
    var i;
    for (i = 0; i < elList.length; i++) {
        var el = elList[i];
        if ( el.style.display != "none" ) {
            el.style.display = 'none';
        } else {
            el.style.display = 'block';
        }
    }
}

function formatXmlDiv(sourceId, targetId) {
    var sourceEl = document.getElementById(sourceId);
    var targetEl = document.getElementById(targetId);

    if (typeof sourceEl !== 'undefined' && sourceEl !== null &&
        typeof targetEl !== 'undefined' && targetEl !== null &&
        targetEl.textContent === 'loading...') {
        targetEl.textContent = "prettifying...";
        targetEl.textContent = vkbeautify.xml(sourceEl.textContent);
    }
}
function formatCompressedXmlDiv(sourceId, targetId) {
    var sourceEl = document.getElementById(sourceId);
    var targetEl = document.getElementById(targetId);

    if (typeof sourceEl !== 'undefined' && sourceEl !== null &&
        typeof targetEl !== 'undefined' && targetEl !== null &&
        targetEl.textContent === 'loading...') {
        targetEl.textContent = "de-base64-ing...";

        try {
            var encodedBase64In = sourceEl.textContent.trim().replace(/\n/g, '');
            console.log("Base64 encoded input first 4 chars: "+encodedBase64In.slice(0, 4));
            var binData = base64js.toByteArray(encodedBase64In);
            // console.log("Base64 decoded output type: "+typeof(binData));
            console.log("Base64 decoded output first 4 bytes: "+binData[0]+" "+binData[1]+" "+binData[2]+" "+binData[3]);
        } catch(err) {
            targetEl.textContent = "ERROR while de-base64-ing";
            console.log("ERROR while de-base64-ing from "+sourceId);
            throw err;
        }

        try {
            targetEl.textContent = "inflating...";
            var inflater = new Zlib.Inflate(binData);
            var uint8array = inflater.decompress();

            var rawDecompressed = new TextDecoder("utf-8").decode(uint8array);
        } catch(err) {
            targetEl.textContent = "ERROR while inflating";
            console.log("ERROR while inflating from "+sourceId);
            throw err;
        }

        try {
            targetEl.textContent = "prettifying...";
            targetEl.textContent = vkbeautify.xml(rawDecompressed);
        } catch(err) {
            targetEl.textContent = "ERROR while prettifying";
            console.log("ERROR while prettifying from "+sourceId);
            throw err;
        }
    }
}
function decompressedDiv(sourceId, targetId) {
    var sourceEl = document.getElementById(sourceId);
    var targetEl = document.getElementById(targetId);

    if (typeof sourceEl !== 'undefined' && sourceEl !== null &&
        typeof targetEl !== 'undefined' && targetEl !== null &&
        targetEl.textContent === 'loading...') {
        targetEl.textContent = "de-base64-ing...";

        try {
            var encodedBase64In = sourceEl.textContent.trim().replace(/\n/g, '');
            console.log("Base64 encoded input first 4 chars: "+encodedBase64In.slice(0, 4));
            var binData = base64js.toByteArray(encodedBase64In);
            // console.log("Base64 decoded output type: "+typeof(binData));
            console.log("Base64 decoded output first 4 bytes: "+binData[0]+" "+binData[1]+" "+binData[2]+" "+binData[3]);
        } catch(err) {
            targetEl.textContent = "ERROR de-base64-ing: "+err;
            console.log("ERROR de-base64-ing from "+sourceId);
            throw err;
        }

        try {
            targetEl.textContent = "inflating...";
            var inflater = new Zlib.Inflate(binData);
            var uint8array = inflater.decompress();

            targetEl.textContent = new TextDecoder("utf-8").decode(uint8array);

            // var data = pako.inflate(binData);
            // Convert gunzipped byteArray back to ascii string:
            // targetEl.textContent = String.fromCharCode.apply(null, new Uint16Array(data));
        } catch(err) {
            targetEl.textContent = "ERROR inflating: "+err;
            console.log("ERROR inflating from "+sourceId+" -> first byte (typically 120): "+binData[0]);
            throw err;
        }
    }
}

function copyDiv(sourceId, targetId) {
    var sourceEl = document.getElementById(sourceId);
    var targetEl = document.getElementById(targetId);

    if (typeof sourceEl !== 'undefined' && sourceEl !== null &&
        typeof targetEl !== 'undefined' && targetEl !== null &&
        targetEl.textContent === 'loading...') {
        targetEl.textContent = "copying...";
        targetEl.textContent = sourceEl.textContent;
    }
}
// function formatJsonDiv(sourceId, targetId) {
//
// }

